local failback = {}

function failback.init()
	if (api and api.gui and api.gui.util and api.gui.comp and api.gui.comp.TextView and commonapi.ui) then
		failback.initXZ()
	end
end

function failback.initXZ()
	local waitid = "CommonAPI2.MainMduFailbackWait"
	if ( api.gui.util.getById(waitid) ) then
		print("Duplicate ID: "..waitid)
		return
	end

	local eleui = api.gui.comp.TextView.new("CommonAPI2 UI waiting for Menu")
	eleui:setId(waitid)
--	local console = api.gui.util.getById("inGameConsole")

--	if (console == nil) then
--		return
--	end

	--local windowcontainer = console:getParent():getParent():getParent()

	local menuui = api.gui.util.getById("menuUI")

	if (menuui == nil) then
		return
	end

	local windowcontainer = commonapi.ui._findByName( menuui:getParent() , "WindowContainer", 1)


	local layout = windowcontainer:getLayout()
	local rect = api.gui.util.Rect.new(10, 10, 100, 100)
	layout:addItem(eleui, rect)

	--commonapi.ui.inspect( commonapi.ui._getRoot() )

	local stepcounter = 0

	local stepfn = function()
		if ( ( stepcounter % 5) == 0) then
			local menui =  api.gui.util.getById("menuUI")
			if ( menui ~= nil) then
				if (menui:getLayout():getNumItems() > 5) then
					failback.showCommonAPISettingsEntry()
					layout:removeItem(eleui)
					eleui:destroy()
				end
			end
		end

		if ( ( stepcounter % 10000) == 0) then
			stepcounter = 0
		end
		if (stepcounter == 400) then
			layout:removeItem(eleui)
			eleui:destroy()
		end

		stepcounter = stepcounter + 1
	end
	eleui:onStep(stepfn)
end


function failback.showCommonAPISettingsEntry()
	local buttonId = "CommonAPI2.MainMenuFailbackButton"
	if (api.gui.util.getById(buttonId)) then
		return
	end

	local menuUIele = api.gui.util.getById("menuUI")
	if (menuUIele) then
		local text = "CommonAPI2: "
		if (commonapi._info.settings.disablenative == true) then
			text = text.._("Native dll/so disabled by settings.lua")
		elseif (commonapi._info.versionunknown == true) then
			text = text.."\n".._("Your Transport Fever 2 version ${ugbuild} isn't listed as known good version, native functionality disabled") %
			{ ugbuild = getBuildVersion() }
		else
			text = text.. commonapi.version
		end

		local buttontext = api.gui.comp.TextView.new(text)
		local button = api.gui.comp.Button.new(buttontext, true)
		button:setId(buttonId)
		--button:setGravity(0, 0.5)
		
		button:onClick(function()
			local ModSettingsWindowTPF = require("commonapi2.uicommon.ModSettingsWindow")
			ModSettingsWindowTPF.createForCommonAPI()
		end)

		local menuuilayout = menuUIele:getLayout()
		menuuilayout:addItem(button, 0, 1)
	end
end

return failback