local SecondaryMenuWindow = {}

local _log = commonapi.utils.logPrep("commonapi2.ui.SecondaryMenuWindow")
local _utils = commonapi.utils
local global_ = _
--local _ = _utils._t

package.loaded["commonapi2.ui2.tpfui"] = nil
local ui = require("commonapi2.ui2.tpfui")

SecondaryMenuWindow = ui.Window:new()

SecondaryMenuWindow.id =  "SecondaryMenuWindow"
SecondaryMenuWindow.caption = ""
SecondaryMenuWindow.uilist = {}

SecondaryMenuWindow.height = 500
SecondaryMenuWindow.width = 500



function SecondaryMenuWindow.create()
	local o
	o = SecondaryMenuWindow:new()
	o:createUIList()
	o:open()
	local cbutton = api.gui.util.getById("mainMenuLeft.CommonAPI2Button.button")
	if (cbutton ~= nil) then
		local cbuttonRect = cbutton:getContentRect()
		local rect = o:getPositionSize()
		o:setPosition(cbuttonRect.x, cbuttonRect.y-rect.h)
	end
	return o
end

function SecondaryMenuWindow:createUIList()
	local uilist = {}

	uilist[#uilist+1] = {
		typ = "Button",
		id = "Settings",
		caption = self._("Settings"),
		onclick = function(item, win)
			win:showSettings()
			win:close()
		end
	}

	uilist[#uilist+1] = {
		typ = "Separator"
	}
	uilist[#uilist+1] = {
		typ = "Button",
		id = "Inspector",
		caption = self._("Inspector"),
		onclick = function(item, win)
			win:showInspector()
			win:close()
		end
	}
---[[
	uilist[#uilist+1] = {
		typ = "Button",
		id = "ReloadLineDestUI",
		caption = self._("Reload Line Destination UI Code"),
		onclick = function(item, win)
			win:reloadLineDestUI()
			win:close()
		end
	}
--]]
	self.uilist = uilist
end

function SecondaryMenuWindow.showSettings()
	package.loaded["commonapi2.uicommon.ModSettingsWindow"] = nil
	package.loaded["commonapi2.uicommon.interface"] = nil
	package.loaded["commonapi2.ui2.tpfui"] = nil
	local ModSettingsWindowTPF = require("commonapi2.uicommon.ModSettingsWindow")
	ModSettingsWindowTPF.createForCommonAPI()
end

function SecondaryMenuWindow.showInspector()
	package.loaded["commonapi2.ui2.tpfui"] = nil
	package.loaded["commonapi2.ui2.inspect"] = nil
	local inspector = require("commonapi2.ui2.inspect")
	inspector.create()
end

function SecondaryMenuWindow.reloadLineDestUI()
	package.loaded["commonapi2.ui2.LineDestination"] = nil
	local LineDestinationUI = require("commonapi2.ui2.LineDestination")
end

return SecondaryMenuWindow