local _utils = commonapi.utils
local _ = _utils._t

local tpfui = {}

local UIEvent = {}
function UIEvent.createClick(obj, item)
	if (item.onclick == nil) then
		return
	end
	if (obj._events == nil) then
		obj._events = {}
	end
	obj._events[#obj._events+1] = {
		item.onclick, item
	}
end

function UIEvent.createDblClick(obj, item)
	if (item.ondblclick == nil) then
		return
	end
	if (obj._events == nil) then
		obj._events = {}
	end
	obj._events[#obj._events+1] = {
		item.ondblclick, item
	}
end


function UIEvent.createChange(obj, item)
	if (item.onchange == nil) then
		return
	end
	if (obj._events == nil) then
		obj._events = {}
	end
	obj._events[#obj._events+1] = {
		item.onchange, item
	}
end

function UIEvent.fireEvents(obj)
	local events = obj._events
	if (events ~= nil and #events > 0) then
		obj._events = {}
		for i, event in ipairs(events) do
			local fn = event[1]
			fn(event[2], obj)
		end
	end
end






local UIItemCreator = {

}

local UIItemDestroyer = {

}


local function _EnsureEleId(ele, id)
	local oldele = api.gui.util.getById(id)
	if (oldele ~= nil) then

		print("_EnsureEleId old id found: ", id)
		commonapi.dmp(oldele)
		--UIItemDestroyer._removeLayoutItemsRecursive(nil, oldele)
		print("_EnsureEleId old id _removeLayoutItemsRecursive end")
		-- if (oldele.getComponent) then
		-- 	commonapi.dmp(ele:getComponent())
		-- end
		if (oldele.remove ~= nil) then
			print("_EnsureEleId remove")
		 	oldele:remove()
		end
		-- if (oldele.getParent) then
		-- 	local parent = oldele:getParent()
		-- 	if (parent ~= nil and parent.removeItem) then
		-- 		parent:removeItem(oldele)
		-- 	end
		-- end
	--	commonapi.dmp(oldele.getNumItems())
		if (oldele.getNumItems) then
			print("_EnsureEleId getNumItems", oldele:getNumItems())
		end

		if (oldele.getComponent) then
			print("_EnsureEleId getComponent")
		end		
		if (oldele.destroy) then
			print("_EnsureEleId destroy")
			oldele:destroy()
			print("_EnsureEleId destroy end")
		end

	end
	ele:setId(id)
end



function UIItemDestroyer._removeLayoutItemsRecursive(win, ele, deep)
	if (ele == nil) then
		return
	end
	if (deep == nil) then
		deep = 0
	end
	local ident = string.rep("    ", deep)

	-- print("UIItemDestroyer._removeLayoutItemsRecursive(win, ", ele:getId(), deep)

	if (ele.getNumItems ~= nil) then
		local numitems = ele:getNumItems()
		if (numitems > 0) then
			for i = numitems, 1, -1 do
				local tmp = ele:getItem(i-1)
				if (tmp.getId ~= nil) then
					--print(ident.."Removing id", tmp:getId())
				end
				if (tmp.getName ~= nil) then
					--print(ident.."Removing name", tmp:getName())
				end
				ele:removeItem(tmp)
				UIItemDestroyer._removeLayoutItemsRecursive(win, tmp, deep+1)
			
				tmp:destroy()
			end
		end
	end
	if (ele.getLayout ~= nil) then
		local layout = ele:getLayout()
		if (layout ~= nil) then
			UIItemDestroyer._removeLayoutItemsRecursive(win, layout, deep+1)
		end
	end

	if (ele.getContent ~= nil) then
		local content = ele:getContent()
		if (content ~= nil) then
			UIItemDestroyer._removeLayoutItemsRecursive(win, content, deep+1)
		end
	end

	-- if (ele.getComponent ~= nil) then
	--  	local comp = ele:getComponent()
	--  	if (comp ~= nil) then
	--  		UIItemDestroyer._removeLayoutItemsRecursive(win, comp, deep+1)
	--  	end
	-- end

end


function UIItemCreator._removeItems(win, item)
	--print("UIItemCreator._removeItems", item.id)
	if (item._oldlist ~= nil) then
		for k, child in pairs(item._oldlist) do
			if (child._uglayout ~= nil) then
				UIItemCreator._removeItems(win, child)
			end
		end
	end
	if (item._uglayout ~= nil) then
		local numitems = item._uglayout:getNumItems()
		if (numitems > 0) then
			for i = numitems, 1, -1 do
				local tmp = item._uglayout:getItem(i-1)
				if (tmp.getId ~= nil) then
					--print("Removing id", tmp:getId())
				end
				item._uglayout:removeItem(tmp)
				tmp:destroy()
			end
		end
	end
end

function UIItemCreator._createitems(win, parent, layout)
--	if (parent._oldlist ~= parent.uilist) then
--[[		local numitems = parent._uglayout:getNumItems()
		if (numitems > 0) then
			for i = numitems, 1, -1 do
				local tmp = parent._uglayout:getItem(i-1)
				parent._uglayout:removeItem(tmp)
				tmp:destroy()
			end
		end
--]]
	if (layout == nil) then
		layout = parent._uglayout
	end
	for k, item in pairs(parent.uilist) do
		local typ = item.typ or "Label"
		local fn = UIItemCreator[typ]
		if (fn ~= nil) then
			if (item.id ~= nil) then
				print("Creating ", item.id)
			end
			local ele = fn(win, item)
			if (ele ~= false and ele ~= nil) then
				layout:addItem(ele)
			end
		end
	end
	parent._oldlist = parent.uilist
--	end
end


function UIItemCreator.ScrollRegion(self, item)
	if (item.id == nil) then
		print("UIItemCreator.ScrollRegion missing id in ", self.id)
		return nil
	end

	local fullid = self._ugidprefix..item.id

	if (item._uglayout == nil) then
		item._uglayout = api.gui.layout.BoxLayout.new("VERTICAL")
		--item._uglayout:setId(fullid.."_layout")
		_EnsureEleId(item._uglayout, fullid.."_layout")
	end
	
	-- item._ugscrollcontent = api.gui.util.getById(fullid.."_scrollcontent")
	if (item._ugscrollcontent == nil) then
		item._ugscrollcontent = api.gui.comp.Component.new("commonapi2_ugscrollcontent")
		--item._ugscrollcontent:setId(fullid.."_scrollcontent")
		_EnsureEleId(item._ugscrollcontent, fullid.."_scrollcontent")
		--item._ugscrollcontent:setMinimumSize(api.gui.util.Size.new(400, 400))
	end
	item._ugscrollcontent:setLayout(item._uglayout)

	local ele = api.gui.comp.ScrollArea.new(item._ugscrollcontent, "XScrollRegion")
	ele:setMaximumSize(api.gui.util.Size.new(-1, -1))
	ele:setGravity(-1,-1)
	--ele:setId(fullid)
	_EnsureEleId(ele, fullid)

--	print("created "..fullid)
	UIItemCreator._createitems(self, item)
	return ele
end


function UIItemCreator.Separator(self, item)
	local ele = api.gui.comp.Component.new("HorizontalLine")
	return ele
end

function UIItemCreator.Label(self, item)
	local ele = api.gui.comp.TextView.new(item.caption or "")
	--ele:setText(item.caption)
	return ele
end


function UIItemCreator.Text(self, item)
	local ele = api.gui.comp.TextView.new(item.caption or "")
	--ele:setText(item.caption)
	return ele
end

function UIItemCreator.Button(self, item)
	local fullid = self._ugidprefix..item.id

	local eletext
	local ele

	-- eletext = api.gui.util.getById(fullid.."_Button")
	if (eletext == nil) then
		eletext = api.gui.comp.TextView.new(item.caption or "Button")
	else
		eletext:setText(item.caption)
	end

--	ele = api.gui.util.getById(fullid)
	if (ele == nil) then
		ele = api.gui.comp.Button.new(eletext, true)
		--ele:setId(fullid)
		_EnsureEleId(ele, fullid)
	end

	local this = self
	local onclickfn = function()
		this.params[item.id] = true
		UIEvent.createClick(this, item)
	end
	ele:onClick(onclickfn)
	return ele
end

function UIItemCreator.Checkbox(self, item)
	local fullid = self._ugidprefix..item.id
	local param
	if (self.params[item.id] ~= nil) then
		param = self.params[item.id]
	else
		param = item.default or false
	end

	local ele -- = api.gui.util.getById(fullid)
	if (ele == nil) then
		ele = api.gui.comp.CheckBox.new(item.caption or "", "ui/checkbox0.tga", "ui/checkbox1.tga")
		--ele:setId(fullid)
		_EnsureEleId(ele, fullid)
	else
		ele:setText(item.caption or "")
	end

	--item.caption or "")
	ele:setSelected(param, false)
	local this = self
	local onToggleFn = function(newbool)
		this.params[item.id] = newbool
		UIEvent.createClick(this, item)
	end
	ele:onToggle(onToggleFn)
	return ele
end


function UIItemCreator.TextInput(self, item)
	local fullid = self._ugidprefix..item.id
	local changed = false
	local param = ""
	local value
	local ok
	
	if (self.params[item.id] ~= nil) then
		param = ""..self.params[item.id]
	elseif(item.default ~= nil) then
		param = ""..item.default or ""
	else
		param = ""
	end
	local ele
	-- = api.gui.util.getById(fullid)
	if (ele == nil) then
		ele = api.gui.comp.TextInputField.new(param)
		--ele:setId(fullid)
		_EnsureEleId(ele, fullid)
		ele:setText(param or "", false)
	else
		ele:setText(param or "", false)
	end
	
	local this = self
	local onChangeFn = function(newvalue)
		if (newvalue == nil) then
			newvalue = ele:getText()
		end

		if (item.typ == "IntValue" or item.typ == "FloatValue") then
			this.params[item.id] = tonumber(newvalue)
		else
			this.params[item.id] = newvalue
		end
		UIEvent.createChange(this, item)
	end
	if (item.changeonenter ~= nil and item.changeonenter == true) then

	else
		ele:onChange(onChangeFn)
	end
	ele:onEnter(onChangeFn)

	return ele
end

UIItemCreator.IntValue = UIItemCreator.TextInput
UIItemCreator.FloatValue = UIItemCreator.TextInput



function UIItemCreator.TabBar(self, item)
	if (item.id == nil) then
		print("UIItemCreator.TabBar missing id in ", self.id)
		return nil
	end

	local fullid = self._ugidprefix..item.id

	
	local tabelement = api.gui.util.getById(fullid)
	if (tabelement == nil) then
		tabelement = api.gui.comp.TabWidget.new("NORTH")
		tabelement:setId(fullid)
	end
	--ele:setId(fullid)
	--_EnsureEleId(tabelement, fullid)
	item._tabelement = tabelement
	item._uglayout = tabelement:getLayout()

	for k, tabitem in pairs(item.uilist) do
		local typ = tabitem.typ or "Label"
		local caption = tabitem.caption or "TabItem"
		if (typ == "TabItem") then
			local fn = UIItemCreator[typ]
			if (fn ~= nil) then
				if (tabitem.id ~= nil) then
					print("Creating ", tabitem.id)
				end
				local ele = fn(self, tabitem)
				if (ele ~= false and ele ~= nil) then
					tabelement:addTabText(caption, ele)
				end
			end
		end
	end

	if (self.params[item.id] ~= nil) then
		tabelement:setCurrentTab(self.params[item.id], false)
	end

	local this = self
	local onChangeFn = function(tabindex)
		this.params[item.id] = tabindex
		UIEvent.createChange(this, item)
	end
	tabelement:onCurrentChanged(onChangeFn)
--	UIItemCreator._createitems(self, item)
	return tabelement
end

function UIItemCreator.TabItem(self, item)
	if (item.id == nil) then
		print("UIItemCreator.TabItem missing id in ", self.id)
		return nil
	end

	local fullid = self._ugidprefix..item.id

	item._uglayout = api.gui.util.getById(fullid.."_layout")
	if (item._uglayout == nil) then
		item._uglayout = api.gui.layout.BoxLayout.new("VERTICAL")
		--item._uglayout:setId(fullid.."_layout")
		_EnsureEleId(item._uglayout, fullid.."_layout")
	end

	if (item._ugtabcontent == nil) then
		item._ugtabcontent = api.gui.comp.Component.new("commonapi2_ugtabcontent")
	--	item._ugtabcontent:setId(fullid.."_tabcontent")
	end
	print("Trying set layout on", item.id)
	item._ugtabcontent:setLayout(item._uglayout)
	print("Trying set layout done", item.id)
	
	UIItemCreator._createitems(self, item)
	return item._ugtabcontent
end


local UIWindow = {
	_open = true,

	id = "",
	uilist = {},
	params = {},
	--["_"] = _G["_"] or commonapi.utils._t
	["_"] = commonapi.utils._t
}

--- UI Window creation function
-- @tparam[opt] table o A table to use while construction
-- @treturn UIWindow
function UIWindow:new(o)
	local o = o or {}

	for k, v in pairs(self) do
		if (o[k] == nil) then
			o[k] = _utils.deepcopy(v)
		end
	end

	o._super = self
	return o
end

function UIWindow:getElementById(id)
	for k, item in pairs(self.uilist) do
		if (item.id == id) then
			return item
		end
	end
	return nil
end

function UIWindow:setPosition(x, y)
	self._ugwindow:setPosition(x, y)
end

function UIWindow:getPositionSize()
	local rect = self._ugwindow:getContentRect()
	local ret = {
		x = rect.x,
		y = rect.y,
		w = rect.w,
		h = rect.h,
	}
	if (rect.w == 0 or rect.h == 0) then
		local minsize = self._ugwindow:calcMinimumSize()
		ret.w = minsize.w
		ret.h = minsize.h
	end
	return ret
end

function UIWindow:_createWindow(caption, layout)
	if (api.gui.comp.Window ~= nil) then
		if (caption == nil) then
			caption = self.id
		end
		return api.gui.comp.Window.new( caption, layout )
	end

	local window = api.gui.comp.Component.new("Window") --CommonAPI2WindowFake")

	--window:setLayout(layout)

	local windowLayout = api.gui.layout.BoxLayout.new("VERTICAL")
	window:setLayout(windowLayout)

	local windowTitleBar = api.gui.comp.Component.new("Window::Title-bar")
	local windowTitleBarLayout = api.gui.layout.BoxLayout.new("VERTICAL")
	windowTitleBar:setLayout(windowTitleBarLayout)

	local windowContent = api.gui.comp.Component.new("Window::Content")
	windowLayout:addItem(windowTitleBar)
	windowLayout:addItem(windowContent)
	windowContent:setLayout(layout)

	local closebuttonIcon = api.gui.comp.ImageView.new("ui/design/window-content/close.tga")
	local closebutton = api.gui.comp.Button.new(closebuttonIcon, true)
	windowTitleBarLayout:addItem(closebutton)

	local that = self
	closebutton:onClick(function()
		that:close()
	end)

	--local windowlayout = api.gui.comp.BoxLayout()
	local menuui = api.gui.util.getById("menuUI")

	if (menuui ~= nil) then
		local windowcontainer = tpfui._findByName( menuui:getParent() , "WindowContainer", 1)
		local windowcontainerlayout = windowcontainer:getLayout()
		local rect = api.gui.util.Rect.new(30, 30, 100, 100)
		windowcontainerlayout:addItem(window, rect)
	end

	return window
end

function UIWindow:_closeWindow(ele)
	print("UIWindow:_closeWindow")
	local parent = ele:getParent()
	local layout = parent:getLayout()
	layout:removeItem(ele)
	ele:destroy()
end

function UIWindow:_fixwindowsize()
	local screenSize = tpfui._getRoot():getContentRect()
	local currentContentRect = o._ugwindow:getContentRect()
	
	
	local newSize = api.gui.util.Size.new(currentContentRect.w, currentContentRect.h)

	local maxw = math.floor(screenSize.w*0.9)
	local maxh = math.floor(screenSize.h*0.9)

	if (currentContentRect.w > maxw) then
		newSize.w = maxw
	end
	if (currentContentRect.h > maxh) then
		newSize.h = maxh
	end
	if (newSize.w > -1 or newSize.h > -1) then
	--	self._ugwindow:setSize(newSize)
	end

	--local maxsize = api.gui.util.Size.new(maxw, maxh)
	--self._uglayout:setMaximumSize(maxsize)
end

function UIWindow:_render()
	self._ugidprefix = "XCoTPF2."..self.id.."."
	local _ugwindow = api.gui.util.getById(self._ugidprefix.."_window")

	if (_ugwindow ~= nil) then
		_ugwindow:remove()
	end

	self._ugwindow = api.gui.util.getById(self._ugidprefix.."_window")
	self._uglayout = api.gui.util.getById(self._ugidprefix.."_layout")
	-- = api.gui.util.getById("XCoTPF2.ModSettingsWindow_eis_os_commonapi2_1._layout")

	print(self._ugidprefix)
	if (self._ugwindow == nil) then

		
		if (self._uglayout == nil) then
			self._uglayout = api.gui.layout.BoxLayout.new("VERTICAL")
			self._uglayout:setId(self._ugidprefix.."_layout")
		end
		--game.gui.window_create(self._ugidprefix.."_window", self.caption or "Test", self._ugidprefix.."_layout")
		--self._ugwindow = api.gui.comp.Window.new( self.caption, self._uglayout )

		self._ugwindow = self:_createWindow( self.caption, self._uglayout )
		

		local screenSize = tpfui._getRoot():getContentRect()
		local maxsize = api.gui.util.Size.new( screenSize.w ,screenSize.h )
		--commonapi.dmp(screenSize)
		--commonapi.dmp(maxsize)
		
		self._ugwindow:setMaximumSize(maxsize)


		self._ugwindow:setId(self._ugidprefix.."_window")
		local that = self
		local closehandler = function()
			that._ugwindow:setVisible(false, false)
		end
		if (self._ugwindow.onClose) then
			self._ugwindow:onClose(closehandler)
		end
		--self._ugwindow = api.gui.util.getById(self._ugidprefix.."_window")
	end
	local this = self
	local stepfn = function()
		local ok, err = pcall(this._fireevents, this)
		if (ok == false) then
			print(err)
		end
		if (this._oldlist ~= nil and this._oldlist ~= this.uilist) then
			UIItemCreator._removeItems(this, this)
			UIItemCreator._createitems(this, this)
			--local result, err = pcall(this._fixwindowsize, this)
			--if (result == false) then
			--	print(err)
			--end
		end
	end
	self._ugwindow:onStep(stepfn)

	if (self._ugwindow.setResizable) then
		self._ugwindow:setResizable(true)
	end
--	UIItemDestroyer._removeLayoutItemsRecursive(self, self._uglayout)
--	print("_removeLayoutItemsRecursive done")
	if (self._oldlist ~= self.uilist) then

		-- local numitems = self._uglayout:getNumItems()
		-- if (numitems > 0) then
		-- 	for i = numitems, 1, -1 do
		-- 		local tmp = self._uglayout:getItem(i-1)
		-- 		self._uglayout:removeItem(tmp)
		-- 		tmp:destroy()
		-- 	end
		-- end
		UIItemCreator._removeItems(self, self)
		UIItemCreator._createitems(self, self)
	end
--[[
	if (self._oldlist ~= self.uilist) then
		local numitems = self._uglayout:getNumItems()
		if (numitems > 0) then
			for i = numitems, 1, -1 do
				local tmp = self._uglayout:getItem(i-1)
				self._uglayout:removeItem(tmp)
				tmp:destroy()
			end
		end
		for k, item in pairs(self.uilist) do
			local typ = item.typ or "Label"
			local fn = UIItemCreator[typ]
			if (fn ~= nil) then
				local ele = fn(self, item)
				if (ele ~= false and ele ~= nil) then
					self._uglayout:addItem(ele)
				end
			end
		end
		self._oldlist = self.uilist
	end
--]]
end

function UIWindow:_fireevents()
	UIEvent.fireEvents(self)

	if (self.changed == true) then
		if (self.onchange ~= nil) then
			self:onchange()
		end
		self.changed = false
	end
end

--- Open this window
--
--
--
-- Warning: Proper id of window needs to be set before use!
function UIWindow:open()
	self._open = true
	self._firstframe = true
	self:_render()
	self._ugwindow:setVisible(true, false)
end

--- Close this window
function UIWindow:close()
	self._open = false
	self._ugelements = nil
	if (self._ugwindow ~= nil) then
		if (self._ugwindow.close == nil) then
			self:_closeWindow(self._ugwindow)
		else
			self._ugwindow:close()
		end
	end
--	if (self._ugwindowlayout ~= nil) then
--		self._ugwindowlayout:destroy()
--		self._ugwindowlayout = nil
--	end
end

tpfui.Window = UIWindow



local function inspectUI(element, xprint, deep)
	local ele = element
	if (type(ele) == "string") then
		ele = api.gui.util.getById(element)
	end

	if (deep == nil) then
		deep = 0
	end

	local ident = string.rep("  ", deep)
	local ident2 = string.rep("  ", deep+1)
	if (ele == nil) then
		xprint(ident.."nil\n")
		return
	end

	local layout
	local content
	local numitems = 0
	local mt = getmetatable(ele)
	local data = {}

	if (mt ~= nil) then
		if (mt.__name ~= nil) then
			data[#data+1] = "typ = "..mt.__name
			--print("mt.__name", mt.__name)
			--if (mt.__name == "sol.UI::TextView*") then 
			--	return
			--end
			if (mt.__index == nil) then
				xprint(ident..data[1] .. " BROKEN!")
				return
			end
		end
	end
	data[#data+1] = "ptr = "..tostring(ele)

	if (ele.getId ~= nil) then
		local id = ele:getId()
		if (id ~= nil) then
			if (id ~= "") then
				data[#data+1] = "id = \""..id.."\""
			end
		end
	end

	if (ele.getName ~= nil) then
		local name = ele:getName()
		if (name ~= nil) then
			if (name ~= "") then
				data[#data+1] = "name = \""..name.."\""
			end
		end
	end

	if (ele.getLayout ~= nil) then
		layout = ele:getLayout()
		if (layout == nil) then
			data[#data+1] = "layout = <nil>"
		end
	end


	if (ele.getNumItems ~= nil) then
		numitems = ele:getNumItems()
		data[#data+1] = "numItems = "..numitems
	end


	if (ele.getContent ~= nil) then
		content = ele:getContent()
		if (content == nil) then
			data[#data+1] = "layout = <nil>"
		end
	end

	if (ele.getText ~= nil) then
		local text = ele:getText()
		if (text == nil) then
			text = "nil"
		end
		data[#data+1] = "text = \""..text:sub(1, 100).."\""
	end

	xprint(ident..table.concat(data, ", "))
	if (layout ~= nil) then
		xprint(ident2.."layout = {")
		inspectUI(layout, xprint, deep+3)
		xprint(ident2.."}")
	end

	if (content ~= nil) then
		xprint(ident2.."content = {")
		inspectUI(content, xprint, deep+3)
		xprint(ident2.."}")
	end

	if (numitems > 0) then
		xprint(ident2.."items = {")
		if (ele.getItem ~= nil) then
			for i = 1, numitems do
				local child = ele:getItem(i-1)
				inspectUI(child, xprint, deep+3)
			end
		else
			xprint(ident2.." <missing getItem function>")
		end
		xprint(ident2.."}")
	end
	--xprint(ident.."\n")
end

--[[
package.loaded["commonapi2.uicommon.interface"] = nil
interface = require("commonapi2.uicommon.interface")
interface.inspect(interface._getRoot())
require("commonapi2.uicommon.interface").inspect("inGameConsole")

x = api.gui.util.getById("inGameConsole")
x:getLayout():getItem(0)
commonapi.dmp( x:getLayout():getItem(0):getLayout():getItem(1) )

win = api.gui.util.getById("inGameConsole")
win:getParent():getParent():getParent():getLayout():getItem(0)
--]]

tpfui.inspect = function(ele, filename)
	local xprint = print
	local file, errstring
	if (type(filename) == "string") then
		file, errstring = io.open(filename, "a")
		if (file ~= nil) then
			xprint = function(var)
				file:write(var.."\n")
			end
		else
			print(errstring)
		end
	end
	inspectUI(ele, xprint)
	if (file ~= nil) then
		file:close()
	end
end


tpfui._getRoot = function()
	local ele = api.gui.util.getById("inGameConsole")

	if (ele == nil) then
		ele = api.gui.util.getById("menuUI")
	end

	if (ele == nil) then
		ele = api.gui.util.getById("mainView")
	end

	if (ele == nil) then
		return nil
	end

	local parent = ele:getParent()
	while(parent) do
		ele = parent
		parent = ele:getParent()
	end
	return ele
end

-- commonapi.ui._findByName( api.gui.util.getById("menuUI"):getParent(), "WindowContainer", 1)
tpfui._findByName = function(parent, name, maxdeep)
	maxdeep = maxdeep or 1
	if (parent.getLayout == nil) then
		return nil
	end
	local layout = parent:getLayout()

	if (layout == nil) then
		return nil
	end

	local numitems = layout:getNumItems()
	for i = 1, numitems do
		local child = layout:getItem(i-1)
		if (child ~= nil) then
			if (child.getName ~= nil) then
				if (child:getName() == name) then
					return child
				end
			end
			if (maxdeep > 1) then
				local ret = tpfui._findByName(child, name, maxdeep-1)
				if (ret ~= nil) then
					return ret
				end
			end
		end
	end
	return nil
end

tpfui._getParentWindow = function(ele)
	if (type(ele) == "string") then
		ele = api.gui.util.getById(ele)
	end
	if (ele == nil) then
		return
	end
	local parent = ele:getParent()
	while(parent) do
		local mt = getmetatable(ele)
		print(">>"..mt.__name.."<<")
		if (mt.__name == "sol.UI::Window*") then
			break
		end
		ele = parent
		parent = ele:getParent()
	end
	return ele
end

---
-- Creates a entry in the commonapi mod menu
-- @tparam string id unique id for this entry
-- @tparam string caption
-- @tparam function fn callback function
function tpfui.createModMenuEntry(id, caption, fn)
end

---
-- Removes id from commonapi mod menu
function tpfui.removeModMenuEntry(id)
end

--- Message Box Creator
-- @tparam string id unique id for this msgbox. (overwrites previous message with same id)
-- @tparam string text
-- @tparam string caption
function tpfui.msgbox(id, text, caption, buttons)

end

function tpfui._activate()

end
return tpfui